package java9modulestest;

import com.sun.star.uno.UnoRuntime;

public class HelloJava9 {

	public static void main(String[] args) {
		System.out.println("Hello from modular java!");

		com.sun.star.uno.XComponentContext xContext = null;
		try {
			// get the remote office component context
			xContext = com.sun.star.comp.helper.Bootstrap.bootstrap();
			if (xContext != null)
				System.out.println("Connected to a running office ...");
		} catch (Exception e) {
			e.printStackTrace(System.err);
			System.exit(1);
		}

		System.out.println("Opening an empty Writer document");
		com.sun.star.text.XTextDocument myDoc = openWriter(xContext);

		// getting the text object
		com.sun.star.text.XText xText = myDoc.getText();

		// create a cursor object
		com.sun.star.text.XTextCursor xTCursor = xText.createTextCursor();

		// inserting some Text
		xText.insertString(xTCursor, "The first line in the newly created text document.\n", false);

		// inserting a second line
		xText.insertString(xTCursor, "Now we're in the second line\n", false);

	}

	public static com.sun.star.text.XTextDocument openWriter(com.sun.star.uno.XComponentContext xContext) {
		com.sun.star.frame.XComponentLoader xCLoader;
		com.sun.star.text.XTextDocument xDoc = null;
		com.sun.star.lang.XComponent xComp = null;

		try {
			// get the remote office service manager
			com.sun.star.lang.XMultiComponentFactory xMCF = xContext.getServiceManager();

			Object oDesktop = xMCF.createInstanceWithContext("com.sun.star.frame.Desktop", xContext);

			xCLoader = UnoRuntime.queryInterface(com.sun.star.frame.XComponentLoader.class, oDesktop);
			com.sun.star.beans.PropertyValue[] szEmptyArgs = new com.sun.star.beans.PropertyValue[0];
			String strDoc = "private:factory/swriter";
			xComp = xCLoader.loadComponentFromURL(strDoc, "_blank", 0, szEmptyArgs);
			xDoc = UnoRuntime.queryInterface(com.sun.star.text.XTextDocument.class, xComp);

		} catch (Exception e) {
			System.err.println(" Exception " + e);
			e.printStackTrace(System.err);
		}
		return xDoc;
	}

}
